base @
decimal

( CORE )
: +! DUP ROT SWAP @ + SWAP ! ;
: , here ! 4 allot ;
: /mod 2dup >r >r mod r> r> / ;
: 0< 0 < ;
: 0= 0 = ;
: 1+ 1 + ;
: 1- 1 - ;
: 2! SWAP OVER ! 4 + ! ;
: 2* 2 * ;
: 2@ DUP 4 + @ SWAP @ ;
: 2drop drop drop ;
: 2swap >r rot rot r> rot rot ;
: 2over 2swap 2dup >r >r 2swap r> r> ;
: ? @ . ;
: ?DUP DUP IF DUP THEN ;
: ABS DUP 0< IF 0 SWAP - THEN ;
: align here 3 and 4 swap - allot ;
: aligned 3 + -4 and ;
: BL 32 ;
: c, here c! 1 allot ;
: cell+ 4 + ;
: constant create here ! 4 allot does> @ ;
: CELL+ 4 + ;
: CELLS 4 * ;
: CHAR+ 1 + ;
: CHARS ;
: COUNT DUP CHAR+ SWAP C@ ;
: CR 13 EMIT 10 EMIT ;
: environment? drop drop 0 ;
: FILL SWAP >R SWAP R> 0 ?DO 2DUP C! 1 + LOOP 2DROP ;
: invert -1 xor ;
: MAX 2DUP < IF SWAP THEN DROP ;
: MIN 2DUP > IF SWAP THEN DROP ;
: negate 0 swap - ;
: r@ r> dup >r ;
: S>D DUP 0< ;
: SPACE 32 EMIT ;
: SPACES 0 ?DO SPACE LOOP ;
: unloop r> drop r> drop ;
: variable create 4 allot ;

( CORE EXT )
: 0<> 0= INVERT ;
: 0> 0 > ;
: 2>R SWAP >R >R ;
: 2R> R> R> SWAP ;
: 2R@ R> R> 2DUP >R >R SWAP ;
: <> = 0= ;
: erase 0 ?do dup 0 swap ! 1 + loop drop ;
: FALSE 0 ;
: NIP SWAP DROP ;
: tib source drop ;
: TRUE -1 ;
: TUCK SWAP OVER ;
: value create here ! 4 allot does> @ ;

( DOUBLE )
: d= ROT = ROT ROT = AND ;
: d0= or 0 = ;
: 2constant create swap , , does> dup @ swap 4 + @ ;

( STRING )
: blank 0 ?do dup bl swap c! 1+ loop drop ;
: -trailing dup 0 ?do 2dup + 1- c@ bl = if 1- else leave then loop ;

base !
